/*
 * Copyright 2022 Omico
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     https://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package me.omico.gradm.internal.codegen

import me.omico.gradm.GradmDevelopmentConfigs
import me.omico.gradm.internal.path.GradmPaths
import kotlin.io.path.writeText

internal fun generateGradleSettingsScript() {
    var content = GradmDevelopmentConfigs.customGradleSettingsScript ?: gradleSettingsScriptContent
    if (content.isBlank()) {
        println("Development: customGradleSettingsScript is blank, fallback to default.")
        content = gradleSettingsScriptContent
    }
    GradmPaths.GeneratedDependenciesProject.gradleSettingsScript.writeText(content)
}

private val gradleSettingsScriptContent: String =
    """
    //
    // Generated by Gradm, will be overwritten by every dependencies update, do not edit!!!
    //

    rootProject.name = "generated-dependencies"

    """.trimIndent().replace("\n", System.lineSeparator())
